532-k-diff-pairs-in-an-array

Try it on leetcode

Description

Given an array of integers nums and an integer k, return the number of unique k-diff pairs in the array.

A k-diff pair is an integer pair (nums[i], nums[j]), where the following are true:

  • 0 <= i < j < nums.length
  • |nums[i] - nums[j]| == k

Notice that |val| denotes the absolute value of val.

 

Example 1:

Input: nums = [3,1,4,1,5], k = 2
Output: 2
Explanation: There are two 2-diff pairs in the array, (1, 3) and (3, 5).
Although we have two 1s in the input, we should only return the number of unique pairs.

Example 2:

Input: nums = [1,2,3,4,5], k = 1
Output: 4
Explanation: There are four 1-diff pairs in the array, (1, 2), (2, 3), (3, 4) and (4, 5).

Example 3:

Input: nums = [1,3,1,5,4], k = 0
Output: 1
Explanation: There is one 0-diff pair in the array, (1, 1).

 

Constraints:

  • 1 <= nums.length <= 104
  • -107 <= nums[i] <= 107
  • 0 <= k <= 107

Solution(Python)

class Solution:
    def findPairs(self, nums: List[int], k: int) -> int:
        return self.HashingSolution(nums, k)

    """
    bruteforce solution is to try all possible n(n-1)/2 pairs from the array of size n
    keep a set with unique difference of value == k
    
    
    Time Complexity: O(n^2)
    Space Complexity: O(n)
    """

    def bruteforceSolution(self, nums: List[int], k: int) -> int:
        seen = set()
        n = len(nums)
        for i in range(n):
            for j in range(i + 1, n):
                if abs(nums[i] - nums[j]) == k:
                    seen.add((nums[i], nums[j]))

        return len(seen)

    """
    Time Complexity: O(n^2)
    Space Complexity: O(1)
    """

    def bruteforceConstantSpaceSolution(self, nums: List[int], k: int) -> int:
        kdiff = 0
        n = len(nums)
        for i in range(n):
            for j in range(i + 1, n):
                if abs(nums[i] - nums[j]) == k:
                    kdiff += 1

        return kdiff

    """
    similar to two sum problem if we hash num1  in hashmap and look for num2+k for the second time we could increment the kidff counter
    
    
    Time Complexity: O(n)
    Space Complexity: O(n)
    
    """

    def HashingSolution(self, nums: List[int], k: int) -> int:
        hashmap = {}

        for num in nums:
            if num not in hashmap:
                hashmap[num] = 1
            else:
                hashmap[num] += 1

        kdiff = 0
        if k == 0:
            for key in hashmap:
                if hashmap[key] > 1:
                    kdiff += 1
        else:

            for num in set(nums):
                if num + k in hashmap:
                    kdiff += 1

        return kdiff